#include <stdlib.h>
#include <stdio.h>

#include <pspkernel.h>
#include <pspdebug.h>
#include <pspdisplay.h>
#include <pspctrl.h>

#include <timeManager.h>

PSP_MODULE_INFO("TimeManager", 0, 1, 0);

int running = 1;

int exit_callback(int arg1, int arg2, void *common)
{
    running = 0;
    sceKernelExitGame();
    return 0;
}

int CallbackThread(SceSize args, void *argp)
{
    int cbid;
    cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
    sceKernelRegisterExitCallback(cbid);
    sceKernelSleepThreadCB();
    return 0;
}

int SetupCallbacks(void)
{
    int thid = 0;
    thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
    if(thid >= 0)
    {
        sceKernelStartThread(thid, 0, 0);
    }

    return thid;
}


int main(int argc, char *argv[])
{
	SetupCallbacks();
	SceCtrlData pad;
	pspDebugScreenInit();

	while (running)
    {
            sceCtrlPeekBufferPositive (&pad, 1);

			pspDebugScreenSetXY(0, 0);
			pspDebugScreenPrintf("\n\tTimeManager version Finale : eboot de d%cmonstration\n\n\n", 0x82);

			pspDebugScreenPrintf("  Appuyez sur X pour lancer le Timer\n");
			pspDebugScreenPrintf("  Appuyez sur O pour arr%cter le Timer\n", 0x88);
			pspDebugScreenPrintf("  Appuyez sur Triangle pour mettre en pause le Timer\n");
			pspDebugScreenPrintf("  Appuyez sur Carr%c pour red%cmarrer le Timer apr%cs une pause\n\n", 0x82, 0x82, 0x8A);

			pspDebugScreenPrintf("  Temps en microsecondes : %llu \n", timer_getTimeMicroSec());
			pspDebugScreenPrintf("  Temps en millisecondes : %llu \n", timer_getTimeMilliSec());
			pspDebugScreenPrintf("  Temps en secondes : %llu \n", timer_getTimeSec());
			pspDebugScreenPrintf("  Temps en minutes : %llu \n", timer_getTimeMin());
			pspDebugScreenPrintf("  Temps en heures : %llu \n\n\n\n", timer_getTimeHours());

            pspDebugScreenPrintf("\tExemple concret : le chronom%ctre\n\n", 0x8A);
            pspDebugScreenPrintf("\t\t%llu :", timer_getTimeHours());
            if (timer_getTimeMin()-60*timer_getTimeHours() < 10) pspDebugScreenPrintf(" 0%llu :", (timer_getTimeMin()-60*timer_getTimeHours()));
            else pspDebugScreenPrintf(" %llu :", (timer_getTimeMin()-60*timer_getTimeHours()));
            if (timer_getTimeSec()-60*timer_getTimeMin() < 10) pspDebugScreenPrintf(" 0%llu \n", (timer_getTimeSec()-60*timer_getTimeMin()));
            else pspDebugScreenPrintf(" %llu \n", (timer_getTimeSec()-60*timer_getTimeMin()));

            if (pad.Buttons & PSP_CTRL_CROSS) timer_start();
            if (pad.Buttons & PSP_CTRL_CIRCLE) timer_reset();
            if (pad.Buttons & PSP_CTRL_TRIANGLE) timer_startPause();
            if (pad.Buttons & PSP_CTRL_SQUARE) timer_endPause();

            sceDisplayWaitVblankStart();
	}


	sceKernelExitGame();
	return 0;
}

